////////////////////////////////////////////////////////////////////////////////
// Copyright Antonin "Destra" Gagelin  
////////////////////////////////////////////////////////////////////////////////

package com.destra.simpleui.display
{
	import com.destra.simpleui.interfaces.IDisposable;
	import flash.display.Sprite;
	import org.osflash.signals.Signal;
	
	/**
	 * @author Antonin 'Destra' Gagelin (destravul[AT]gmail[DOT]com)
	 * Oct 16, 2013
	 */
	public class Button extends Sprite implements IDisposable
	{
		////////////////////////////////////////////////////////////
		//::// Members 
		////////////////////////////////////////////////////////////
		
		// Signals
		private var _clickSignal : Signal;
		
		// Other stuff
		private var _disposed : Boolean = false;
		
		////////////////////////////////////////////////////////////
		//::// Signals 
		////////////////////////////////////////////////////////////
		
		/**
		 * Dispatched when clicking on the button.</br>
		 *  Signal param : <code>Button</code>
		 */
		public function get onClick() : Signal
		{
			return _clickSignal;
		}
		
		////////////////////////////////////////////////////////////
		//::// Properties 
		////////////////////////////////////////////////////////////
		
		public function get isDisposed() : Boolean
		{
			return _disposed;
		}
		
		////////////////////////////////////////////////////////////
		//::// Constructor 
		////////////////////////////////////////////////////////////
		
		public function Button()
		{
			super();
			
			_clickSignal = new Signal(Button);
		}
		
		////////////////////////////////////////////////////////////
		//::// Public methods 
		////////////////////////////////////////////////////////////
		
		public function dispose() : void
		{
			if(_disposed)
				return;
			
			if(_clickSignal)
				_clickSignal.removeAll();
			_clickSignal = null;
			
			_disposed = true;
		}
	}
}
